include \masm32\include\masm32rt.inc
include gdip.inc
include gdiplus.inc
includelib gdiplus.lib
.686p
.mmx
.xmm
include \macros\SmplMath\math.inc	; http://sourceforge.net/projects/smplmath/


WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
CenterClientArea proto hWnd:DWORD,SizeFactorX:REAL4,SizeFactorY:REAL4,pClientWidth:ptr DWORD,pClientHeigth: ptr DWORD
GdipAddPathRectRoundCorners proto path:PVOID,x:REAL4,y:REAL4,nx:REAL4,ny:REAL4,r:REAL4

WND_DATA struct
	hdc		HDC 	?
	hBmp	HBITMAP	?
WND_DATA ends

.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG
LOCAL gsi:GdiplusStartupInput
LOCAL gtkn:PULONG
LOCAL hInstance:HINSTANCE

	mov gsi.GdiplusVersion,1
	mov gsi.DebugEventCallback,0
	mov gsi.SuppressBackgroundThread,0
	mov gsi.SuppressExternalCodecs,0
	invoke GdiplusStartup,ADDR gtkn,ADDR gsi,0

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32, GDI+")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,NULL,wcex.lpszClassName,"Win32, GDI+",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL)
	invoke ShowWindow,esi,SW_SHOWNORMAL
	invoke UpdateWindow,esi

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	
	invoke GdiplusShutdown,gtkn
	invoke ExitProcess,msg.wParam

main endp


GdipAddPathRectRoundCorners proc path:PVOID,x:REAL4,y:REAL4,nx:REAL4,ny:REAL4,r:REAL4
LOCAL fSlvTLS()
LOCAL D:REAL4

	fSlv D = 2*r
	invoke GdipStartPathFigure,path
	invoke GdipAddPathArc,path,x,y,D,D,R4(180),R4(90)
	invoke GdipAddPathLine,path,@fSlv4(x+r),y,@fSlv4(x+nx-r),@fSlv4(y)
	invoke GdipAddPathArc,path,@fSlv4(x+nx-D),y,D,D,R4(270),R4(90)
	invoke GdipAddPathLine,path,@fSlv4(x+nx),@fSlv4(y+r),@fSlv4(x+nx),@fSlv4(y+ny-r)
	invoke GdipAddPathArc,path,@fSlv4(x+nx-D),@fSlv4(y+ny-D),D,D,0,R4(90)
	invoke GdipAddPathLine,path,@fSlv4(x+r),@fSlv4(y+ny),@fSlv4(x+nx-r),@fSlv4(y+ny)
	invoke GdipAddPathArc,path,x,@fSlv4(y+ny-D),D,D,R4(90),R4(90)
	invoke GdipAddPathLine,path,x,@fSlv4(y+r),x,@fSlv4(y+ny-r)
	invoke GdipClosePathFigure,path
	
	ret
	
GdipAddPathRectRoundCorners endp

; This function draws and/or highlight a button.
; brFill: brush used for drawing the button before highlighting
; pRectF: button's bounding box
; r:      radius of corners
; f1/2:   factor for positioning the "highlighting-circle" (relativ to button's height)
; sx/y:   stretching of the gradient which goes from border to center
; wPen:   width of pen which is used for outline
; c1/2:   gradient: button border to center
; c3/4:   gradient: cirecle center to circle-border
; c5/6:   gradient: top down (pen)
GdipHighlightButton proc uses ebx edi esi graphics:PVOID,brFill:PVOID,pRectF: ptr RectF,r:REAL4,f1:REAL4,f2:REAL4,sx:REAL4,sy:REAL4,wPen:REAL4,c1:ARGB,c2:ARGB,c3:ARGB,c4:ARGB,c5:ARGB,c6:ARGB
LOCAL fSlvTLS()
LOCAL brush:PVOID
LOCAL pen:PVOID
LOCAL pathClip:PVOID
LOCAL pathEllips:PVOID
LOCAL pathGradBrush:PVOID
LOCAL region:PVOID
LOCAL count:DWORD
LOCAL pt[2]:PointF
LOCAL x[3]:REAL4,y[3]:REAL4,a[4]:REAL4,b[4]:REAL4,x0:REAL4,y0:REAL4
	
	mov ebx,pRectF
	.if fLE([ebx].RectF._Width,0) || fLE([ebx].RectF.Height,0)
		mov eax,GpStatusInvalidParameter
		ret		
	.endif
	
	.if fLE(f1,f2)
		mov eax,GpStatusInvalidParameter
		ret		
	.endif
	
	; save current clipping region
	invoke GdipCreateRegion,ADDR region
	invoke GdipGetClip,graphics,region
	
	invoke GdipCreatePath,0,ADDR pathClip
	
	; create button's path (=shape)
	invoke GdipAddPathRectRoundCorners,pathClip,[ebx].RectF.x,[ebx].RectF.y,[ebx].RectF._Width,[ebx].RectF.Height,r
	invoke GdipSetClipPath,graphics,pathClip,CombineModeReplace
	invoke GdipFillPath,graphics,brFill,pathClip
	
	invoke GdipCreatePathGradientFromPath,pathClip,ADDR pathGradBrush
	fSlv pt.x = [ebx].RectF.x + [ebx].RectF._Width * 0.5
	fSlv pt.y = [ebx].RectF.y + [ebx].RectF.Height * 0.5
	invoke GdipSetPathGradientCenterPoint,pathGradBrush,ADDR pt
	invoke GdipSetPathGradientCenterColor,pathGradBrush,c2
	mov count,1
	invoke GdipSetPathGradientSurroundColorsWithCount,pathGradBrush,ADDR c1,ADDR count
	invoke GdipTranslatePathGradientTransform,pathGradBrush,@fSlv4(-pt.x),@fSlv4(-pt.y),MatrixOrderAppend
	invoke GdipScalePathGradientTransform,pathGradBrush,sx,sy,MatrixOrderAppend
	invoke GdipTranslatePathGradientTransform,pathGradBrush,@fSlv4(pt.x),@fSlv4(pt.y),MatrixOrderAppend
	invoke GdipFillPath,graphics,pathGradBrush,pathClip
	invoke GdipDeleteBrush,pathGradBrush

	; calculate highlighting-circle (from 3 points)
	fSlv x[0] = [ebx].RectF.x + [ebx].RectF._Width * 0.5
	fSlv x[4] = [ebx].RectF.x
	fSlv x[8] = [ebx].RectF.x + [ebx].RectF._Width
	fSlv y[0] = [ebx].RectF.y + [ebx].RectF.Height * f1
	fSlv y[4] = [ebx].RectF.y + [ebx].RectF.Height * f2
	fSlv y[8] = y[4]
	fSlv a[0] =(y[0]-y[4])/(x[0]-x[4])
	fSlv a[4] =(y[0]-y[8])/(x[0]-x[8])
	fSlv a[8] =(y[0]^2-y[4]^2+x[0]^2-x[4]^2)/(2*(x[0]-x[4]))
	fSlv a[12]=(y[0]^2-y[8]^2+x[0]^2-x[8]^2)/(2*(x[0]-x[8]))
	fSlv b[0] =(x[0]-x[4])/(y[0]-y[4])
	fSlv b[4] =(x[0]-x[8])/(y[0]-y[8])
	fSlv b[8] =(y[0]^2-y[4]^2+x[0]^2-x[4]^2)/(2*(y[0]-y[4]))
	fSlv b[12]=(y[0]^2-y[8]^2+x[0]^2-x[8]^2)/(2*(y[0]-y[8]))
	fSlv x0=(b[8]-b[12])/(b[0]-b[4])
	fSlv y0=(a[8]-a[12])/(a[0]-a[4])
	
	fSlv r = sqrt((x0-x[0])^2+(y0-y[0])^2)
	
	invoke GdipCreatePath,0,ADDR pathEllips
	invoke GdipAddPathEllipse,pathEllips,@fSlv4(x0-r),@fSlv4(y0-r),@fSlv4(2*r),@fSlv4(2*r)
	invoke GdipAddPathEllipse,pathEllips,@fSlv4(x0-(r-[ebx].RectF.Height*f1)),@fSlv4(y0-(r-[ebx].RectF.Height*f1)),@fSlv4(2*(r-[ebx].RectF.Height*f1)),@fSlv4(2*(r-[ebx].RectF.Height*f1))
	invoke GdipCreatePathGradientFromPath,pathEllips,ADDR pathGradBrush
	fSlv pt.x = [ebx].RectF.x + [ebx].RectF._Width * 0.5
	fSlv pt.y = [ebx].RectF.y
	invoke GdipSetPathGradientCenterPoint,pathGradBrush,ADDR pt

	invoke GdipSetPathGradientCenterColor,pathGradBrush,c4
	mov count,1
	invoke GdipSetPathGradientSurroundColorsWithCount,pathGradBrush,ADDR c3,ADDR count

	invoke GdipFillEllipse,graphics,pathGradBrush,@fSlv4(x0-r),@fSlv4(y0-r),@fSlv4(2*r),@fSlv4(2*r)

	invoke GdipSetClipRegion,graphics,region,CombineModeReplace

	fSlv pt.x = [ebx].RectF.x
	fSlv pt.y = [ebx].RectF.y - [ebx].RectF.Height*0.1
	fSlv pt[8].x = [ebx].RectF.x
	fSlv pt[8].y = [ebx].RectF.y + [ebx].RectF.Height*1.1
	invoke GdipCreateLineBrush,ADDR pt[0],ADDR pt[8],c5,c6,0,ADDR brush
	invoke GdipCreatePen1,0,wPen,UnitWorld,ADDR pen
	invoke GdipSetPenMode,pen,PenAlignmentCenter
	invoke GdipSetPenBrushFill,pen,brush
	invoke GdipDrawPath,graphics,pen,pathClip

	invoke GdipDeletePath,pathClip
	invoke GdipDeletePath,pathEllips
	invoke GdipDeletePen,pen
	invoke GdipDeleteBrush,brush
	invoke GdipDeleteBrush,pathGradBrush
	invoke GdipDeleteRegion,region
	
	ret
	
GdipHighlightButton endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL fSlvTLS()
LOCAL ps:PAINTSTRUCT
LOCAL graphics:PVOID
LOCAL brush:PVOID
LOCAL path:PVOID
LOCAL rectf:RectF

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		invoke DeleteObject,rv(SelectObject,ebx,rv(GetWindowLong,hWnd,WND_DATA.hBmp))
		invoke DeleteDC,ebx
	.elseif uMsg == WM_CREATE
		invoke CenterClientArea,hWnd,R4(0.6),R4(0.6),ADDR ps.rcPaint.left,ADDR ps.rcPaint.top
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		invoke SetWindowLong,hWnd,WND_DATA.hBmp,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,ps.rcPaint.left,ps.rcPaint.top))
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		invoke GdipCreateFromHDC,ebx,ADDR graphics
		invoke GdipGraphicsClear,graphics,ColorsWhite	
		invoke GdipSetSmoothingMode,graphics,SmoothingModeHighQuality
		
		; create brush for button. (This can be any brush-type)
		invoke GdipCreateSolidFill,ColorsRed,ADDR brush
		
		; dimensions of button
		ldl rectf.x = 10, rectf.y = 10, rectf._Width = 100, rectf.Height = 50

		; color-set for button-highlighting
		C1 = ColorsBlack									; gradient 1: from button border to center
		C2 = (ColorsWhite AND 0ffffffh) OR (255/5 SHL 24)	;
		
		C3 = 0												; gradient 2: circular segment drawn in the upper half of the button
		C4 = (ColorsWhite AND 0ffffffh) OR (255/3 SHL 24)	; (gradient from circle center to border)
		
		C5 = (ColorsBlack AND 0ffffffh) OR (255/2 SHL 24)	; gradient 3: used to outline the button
		C6 = (ColorsBlack AND 0ffffffh) OR (255/8 SHL 24)	;
		
		; draw button 1
		invoke GdipHighlightButton,graphics,brush,ADDR rectf,R4(10),R4(0.4),R4(0.35),R4(10),R4(5),R4(1),C1,C2,C3,C4,C5,C6
		
		; draw button 2
		ldl rectf.y = 20 + 50
		C3 = (ColorsWhite AND 0ffffffh) OR (255/4 SHL 24)
		C4 = ColorsWhite
		invoke GdipHighlightButton,graphics,brush,ADDR rectf,R4(10),R4(0.4),R4(0.35),R4(10),R4(5),R4(1),C1,C2,C3,C4,C5,C6
		
		; draw button 3
		ldl rectf.y = 20 + 50 , rectf.x = 20 + 110
		C3 = 0
		C4 = (ColorsWhite AND 0ffffffh) OR (255/3 SHL 24)
		invoke GdipHighlightButton,graphics,brush,ADDR rectf,R4(10),R4(0.4),R4(0.35),R4(1),R4(1),R4(1),C1,C2,C3,C4,C5,C6		

		; draw button 4
		invoke GdipSetSolidFillColor,brush,ColorsBlue
		ldl rectf.y = 10 , rectf.x = 20 + 110
		C3 = 0
		C4 = (ColorsWhite AND 0ffffffh) OR (255/3 SHL 24)
		C5 = ColorsBlack
		invoke GdipHighlightButton,graphics,brush,ADDR rectf,R4(10),R4(0.4),R4(0.35),R4(10),R4(5),R4(1.5),C1,C2,C3,C4,C5,C6

		; draw button 5
		invoke GdipSetSolidFillColor,brush,ColorsBlue
		ldl rectf.y = 20 + 50 + 10 + 50, rectf.x = 10
		C5 = ColorsDarkBlue
		C6 = ColorsLightBlue
		invoke GdipHighlightButton,graphics,brush,ADDR rectf,R4(10),R4(0.4),R4(0.35),R4(10),R4(5),R4(1),C1,C2,C3,C4,C5,C6

		; draw button 6
		invoke GdipSetSolidFillColor,brush,0
		ldl rectf.y = 150, rectf.x = 90
		C5 = ColorsDarkBlue
		C6 = ColorsLightBlue
		invoke GdipHighlightButton,graphics,brush,ADDR rectf,R4(10),R4(0.4),R4(0.35),R4(10),R4(5),R4(1),C1,C2,C3,C4,C5,C6

		; draw button 7
		invoke GdipSetSolidFillColor,brush,0
		ldl rectf.x = 250, rectf.y = 10 ,rectf._Width = 150, rectf.Height = 110
		C1 = ColorsDarkBlue
		C2 = (ColorsSkyBlue AND 0ffffffh) OR (255/4 SHL 24)
		C3 = (ColorsSkyBlue AND 0ffffffh) OR (255/12 SHL 24)
		C4 = (ColorsBlue AND 0ffffffh) OR (255/6 SHL 24)
		C5 = (ColorsDarkBlue AND 0ffffffh) OR (255/2 SHL 24)
		C6 = ColorsLightBlue
		invoke GdipHighlightButton,graphics,brush,ADDR rectf,R4(20),R4(1),R4(0.99),R4(10),R4(5),R4(1),C1,C2,C3,C4,C5,C6

		invoke GdipDeleteBrush,brush
		
		invoke GdipDeleteGraphics,graphics
		
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps	
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

CenterClientArea proc hWnd:DWORD,SizeFactorX:REAL4,SizeFactorY:REAL4,pClientWidth:ptr DWORD,pClientHeigth: ptr DWORD
LOCAL cxScreen:DWORD
LOCAL cyScreen:DWORD
LOCAL dwStyle:DWORD
LOCAL dwExStyle:DWORD
LOCAL bMenu:DWORD
LOCAL rect:RECT

	mov cxScreen,rv(GetSystemMetrics,SM_CXSCREEN)
	mov cyScreen,rv(GetSystemMetrics,SM_CYSCREEN)

	fSlv  = cxScreen*SizeFactorX*0.5
	fSlv  = cxScreen*0.5
	fSlv rect.left  = st0 - st1
	fSlv rect.right = st0 + st1
	fstp st
	fstp st
	
	fSlv  = cyScreen*SizeFactorY*0.5
	fSlv  = cyScreen*0.5
	fSlv rect.top    = st0 - st1
	fSlv rect.bottom = st0 + st1
	fstp st
	fstp st	

	mov ecx,rect.right
	sub ecx,rect.left
	mov edx,rect.bottom
	sub edx,rect.top
	
	.if pClientWidth
		mov eax,pClientWidth
		mov DWORD ptr [eax],ecx
	.endif
	.if pClientHeigth
		mov eax,pClientHeigth
		mov DWORD ptr [eax],edx
	.endif

	mov dwStyle,rv(GetWindowLong,hWnd,GWL_STYLE)
	mov dwExStyle,rv(GetWindowLong,hWnd,GWL_EXSTYLE)
	.if dwStyle & WS_CHILD
		mov bMenu,0
	.else
		mov bMenu,rv(GetMenu,hWnd)
	.endif
	
	invoke AdjustWindowRectEx,ADDR rect,dwStyle,bMenu,dwExStyle
	mov ecx,rect.right
	sub ecx,rect.left
	mov edx,rect.bottom
	sub edx,rect.top
	invoke MoveWindow,hWnd,rect.left,rect.top,ecx,edx,TRUE

	ret

CenterClientArea endp

end main
